	;listing off	; we don't need to generate anything for a listing file
	;MACEXP  off
	MACEXP  on
	PAGE    0

	CPU	68000
	binclude "Sonic1.sms", 0, $C000

	CPU	Z80
	phase	4000h
	include "S1SMS_sound_ASX.asm"
	dephase
	org	10000h

	CPU	68000
	binclude "Sonic1.sms", $10000

	padding	off


	; --- insert FM Chip Detection ---
	org	$0003
	; uses 0003-0012
	dc.b	$3A, $00, $C0	; LD	A, (0C000h)	; BIOS Chip Settings
	dc.b	$32, $F0, $DF	; LD	(0DFF0h), A	; save at a safe place
	; when doing a soft-reset, we will jump here (offset 0009h)
	dc.b	$F3		; DI
	; now restore the overwritten init-code
				; InitWait:
	dc.b	$DB, $7E	; IN	A, (7Eh)
	dc.b	$FE, $B0	; CP	0B0h
	dc.b	$20, $FA	; JR	NZ, InitWait
	dc.b	$C3, $8B, $02	; JP	Main (028Bh)
	
	org	$02CE
	dc.b	$2B, $00	; replace destination of CALL
	org	$002B
	dc.b	$3E, $03	; LD	A, 03h		; load Music Bank
	dc.b	$32, $FE, $FF	; LD	(0FFFEh), A	; set Bank Area 1
	dc.b	$CD, $03, $40	; CALL	j_FM_Detection (4003h)
	dc.b	$18, $EB	; JR	j_muteSound (0020h)
	
	; fix Soft-Reset
	org	$00E0
	dc.b	$09, $00	; replace destination of JP


    if 1
    ;  --- Bonus Feature --- 
    ; Extra Song (GHZ with Intro) after Dying in GHZ2
	; Step 1 - reset Dying counter
	org	$2012		; patch routine where current Level is incremented (1FA9h)
	; Original Code (moved to 0326h):
	;	3E 01	LD	A, 01h
	;	C9	RET
	dc.b	$C3, $23, $03	; JP	0323h
	
	org	$0323	; $10 unused bytes (0323-0332)
	; uses 0323-0328
	dc.b	$AF		; XOR	A
	dc.b	$32, $01, $DC	; LD	(DC01h), A
	dc.b	$3C		; INC	A	; return value must be A = 1
	dc.b	$C9		; RET

	; Step 2 - when dying, increment Counter
	; uses 0329-0330
	dc.b	$3E, $0A	; LD	A, 0Ah		; 0A - Death Jingle
	dc.b	$DF		; RST	j_PlayMusic (0018h)
	dc.b	$21, $01, $DC	; LD	HL, 0DC01h	; It is safe to trash HL here.
	dc.b	$34		; INC	(HL)
	dc.b	$C9		; RET
	
	; Note: The Drowning routine is at ROM offset 5009h.
	org	$3640	; patch Death routine (3618h)
	; Original Code (moved to 0329h):
	;	3E 0A	LD	A, 0Ah		; 0A - Death Jingle
	;	DF	RST	j_PlayMusic (0018h)
	dc.b	$CD, $29, $03	; CALL	0329h

	; Step 3 - when loading the level
	org	$2311	; patch Level Loading routine (20CBh), music loading part
	; Original Code:
	;	32 FC D2	LD	($D2FCh), A
	;	DF		RST	j_PlayMusic (0018h)
	dc.b	$CD, $97, $03	; CALL	0397h (replaces first command only)
	
	org	$0397	; $15+$59 unused bytes
	dc.b	$47		; 0397	LD	B, A		; (Yes, I can safely trash B.)
	dc.b	$3A, $3E, $D2	; 0398	LD	A, (0D23Eh)	; load Current Level ID
	dc.b	$FE, $01	; 039B	CP	01h		; is Green Hill 2?
	dc.b	$20, $08	; 039D	JR	NZ, finish	; no - return
	dc.b	$3A, $01, $DC	; 039F	LD	A, (0DC01h)	; load Dying Counter
	dc.b	$B7		; 03A2	OR	A		; test value
	dc.b	$28, $02	; 03A3	JR	Z, finish	; 0 - everything is normal
	dc.b	$06, $11	; 03A5	LD	B, 11h		; Song ID of "Green Hill with Intro"
				; finish:
	dc.b	$78		; 03A7	LD	A, B
	dc.b	$32, $FC, $D2	; 03A8	LD	(0D2FCh), A	; save to "Current Level Music" (the instruction I replaced)
	dc.b	$C9		; 03AB	RET
    endif


    if 1
    ;  --- Bonus Feature --- 
    ; Extra Song (Marble Zone) when completing with all emeralds
	; Step 1 - reset Dying counter
	org	$2020		; patch routine where current Level is incremented (1FA9h), Final Boss part
	; Original Code (moved to 03B8h):
	;	3E FF	LD	A, FFh
	;	C9	RET
	dc.b	$C3, $B8, $03	; JP	03B8h
	
	org	$03B8
	; uses 03B8-03BD
	dc.b	$AF		; XOR	A
	dc.b	$32, $01, $DC	; LD	(DC01h), A
	dc.b	$3D		; DEC	A	; return value must be A = FF
	dc.b	$C9		; RET
	
	; Step 2 - set Dying Counter when having enough emeralds (258B)
	org	$2608
	; Original Code:
	;	3E 13	LD	A, 13h
	;	DF	RST	j_PlayMusic (0018h)
	dc.b	$CD, $BE, $03	; CALL	03BEh
	
	org	$03BE
	; uses 03BE-03C6
	dc.b	$3E, $80	; LD	A, 80h
	dc.b	$32, $01, $DC	; LD	(DC01h), A
	dc.b	$3E, $13	; LD	A, 13h
	dc.b	$DF		; RST	j_PlayMusic (0018h)
	dc.b	$C9		; RET
	
	; Step 3 - Play Marble Zone
	org	$2708	; patch Display Screen routine (258B), Credits part
	; Original Code:
	;	3E 0E	LD	A, 0Eh		; 0E - Ending Theme
	;	DF	RST	j_PlayMusic (0018h)
	dc.b	$CD, $AC, $03	; CALL	03ACh
	
	org	$03AC
	dc.b	$3A, $01, $DC	; 03AC	LD	A, (0DC01h)
	dc.b	$FE, $80	; 03AF	CP	80h
	dc.b	$3E, $0E	; 03B1	LD	A, 0Eh		; 0E - Ending Theme
	dc.b	$20, $01	; 03B3	JR	NZ, finish
	dc.b	$3C		; 03B5	INC	A		; 0F - Marble Zone
				;finish:
	dc.b	$DF		; 03B6	RST	j_PlayMusic (0018h)
	dc.b	$C9		; 03B7	RET
    endif
    
    
    if 1
	; --- toggle FM playback on title screen ---
	
	; Step 1: set a certain bit that tells us when the title screen is shown.
	org	$1C92
	; Original Code:
	;	CD 87 12	CALL	1287h	; do Title Screen
	dc.b	$CD, $C7, $03
	
	org	$03C7
	; uses 03C7-03D4
	dc.b	$21, $00, $DC	; LD	HL, (DC00h)
	dc.b	$CB, $E6	; SET	4, (HL)
	dc.b	$CD, $87, $12	; CALL	1287h	; do Title Screen
	dc.b	$21, $00, $DC	; LD	HL, (DC00h)
	dc.b	$CB, $A6	; RES	4, (HL)
	dc.b	$C9		; RET
	
	; Step 2: toggle FM music by pressing the START button
	org	$006D
	; Original Code:
	;	FD 77 07	LD	(IY+07h), A
	dc.b	$CD, $D5, $03
	
	org	$03D5
	; uses 03D5-03E8
	dc.b	$FD, $77, $07	; LD	(IY+07h), A
	dc.b	$3A, $00, $DC	; LD	A, (0DC00h)
	dc.b	$B7		; OR	A
	dc.b	$F0		; RET	P	; return when FM is not available
	dc.b	$CB, $67	; AND	10h
	dc.b	$C8		; RET	Z	; not on Title Screen - return
	
	dc.b	$EE, $01	; XOR	01h	; toggle FM music bit
	dc.b	$32, $00, $DC	; LD	(0DC00h), A	; write back
	dc.b	$3E, $06	; LD	A, 06h		; 06 - Title Theme
	dc.b	$DF		; RST	j_PlayMusic (0018h)
	dc.b	$C9		; RET
    endif
    
    if 1
	; --- play Game Over tune ---
	; Notes:
	;	- The Game Over screen routine starts at 1401
	;	- D284 contains the number of Continues
	
	org	$1444	; This is right after the Game Over is shown.
	; Original Code:
	;	FB		EI
	;	06 78		LD	BC, 00B4h
	dc.b	$CD, $E9, $03	; CALL	03E9h
	org	$03E9
     if 0
	; uses 03E9-03EF
	dc.b	$06, $78	; LD	BC, 00B4h
	dc.b	$3E, $15	; LD	A, 15h		; 15 - Game Over
	dc.b	$DF		; RST	j_PlayMusic (0018h)
	;dc.b	$FB		; EI	; already done by PlayMusic
	dc.b	$C9		; RET
      else
	; uses 03E9-03E6
	dc.b	$06, $78	; 03E9	LD	BC, 00B4h
	dc.b	$3A, $84, $D2	; 03EB	LD	A, (0D284h)
	dc.b	$B7		; 03EE	OR	A
	dc.b	$3E, $15	; 03EF	LD	A, 15h		; 15 - Game Over
	dc.b	$20, $01	; 03F1	JR	NZ, finish
	dc.b	$3C		; 03F3	INC	A		; 16 - Game Over (short)
	dc.b	$DF		; 03F4	RST	j_PlayMusic (0018h)
	dc.b	$C9		; 03F5	RET
      endif
    endif

	org	$0058
	dc.b	", Valley Bell"
	
	; free space: 03F7-0404

; TODO: Fix checksum (add all bytes, minus the $10 byte header at 07FF0-07FFF)
;
; MESS Debugging Commands:
;	bpset C77E	// Checksum Calculation
;	bpset BEE8	// Checksum Check
