; ---------------------------------------------------------------------------

TrackSize	= 30h

PSG_VolReduce	= 0	; volume 1/4 (the OPLL is always so quiet....)

SndData_ASMed	= 1

SFXListData: macro	DataPtr, Priority
		dw	DataPtr
		db	Priority
		db	00h	; padding
	endm

ClipToVol0F: macro
		cp	10h
		jr	c, clip_done
		ld	a, 0Fh
clip_done:
	endm

ClipToVolF0: macro
		jr	nc, clip_done
		ld	a, 0F0h
clip_done:
	endm

;SFXListData	struc ; (sizeof=0x4)
;DataPtr:	dw ?			; offset
;Priority:	db ?
;padding:	db ?
;SFXListData	ends

; ---------------------------------------------------------------------------

;Group2_2: macro	Offset, Data
;		dw	Offset
;		dw	Data
;	endm

;Group2_2	struc ; (sizeof=0x4)
;Offset:	dw ?			; offset
;Data:		dw ?
;Group2_2	ends

; ---------------------------------------------------------------------------

;Group2_1: macro	Offset, Data
;		dw	Offset
;		db	Data
;	endm

;Group2_1	struc ; (sizeof=0x3)
;Offset:	dw ?			; offset
;Data:		db ?
;Group2_1	ends


YMWait_Reg: macro	tookcycles	; required delay according to manual: 12 cycles
remcycles := 12 - (tookcycles)
	    while remcycles > 0
		nop
remcycles := remcycles - 4
	    endm
	endm

YMWait_Data: macro	; required delay according to manual: 84 cycles
	; However, Phantasy Star waits just 68 cycles when writing the frequency.
	; So assume that 48 cycles should be enough.
		call	WaitForYM	; cycles: 17 (call) + 10 (ret) + 11 (push) + 10 (pop) = 48
	endm

;
; +-------------------------------------------------------------------------+
; |   This file	has been generated by The Interactive Disassembler (IDA)    |
; |	      Copyright	(c) 2011 Hex-Rays, <support@hex-rays.com>	    |
; |			 License info: 48-327F-7274-B7			    |
; |			       ESET spol. s r.o.			    |
; +-------------------------------------------------------------------------+
;
; Input	MD5   :	C91EBEF20EF1173DF56D3F20AF637FAD
; Input	CRC32 :	A727ED4C

; ---------------------------------------------------------------------------
; File Name   :	D:\VStudio-Programme\ASM68k\SoundDrvs\S1SMSdump.bin
; Format      :	Binary file
; Base Address:	0000h Range: 0000h - 10000h Loaded length: 10000h

; Processor	  : z80	[]
; Target assembler: Zilog Macro	Assembler

; ===========================================================================

; Segment type:	Regular
	;	segment	BANK1
	;	org	4000h
		phase	4000h

; =============== S U B	R O U T	I N E =======================================

; Attributes: thunk

j_UpdateSound:				; CODE XREF: BANK0:00CBp
		jp	UpdateSound
; End of function j_UpdateSound

; ---------------------------------------------------------------------------
		;jp	LoadMusic
j_FM_Detection:
		jp	FM_Detection

; =============== S U B	R O U T	I N E =======================================

; Attributes: thunk

j_StopAllSound:				; CODE XREF: sub_2ED+6p
		jp	StopAllSound	; also 'PauseMusic'
; End of function j_StopAllSound


; =============== S U B	R O U T	I N E =======================================

; Attributes: thunk

j_UnpauseMusic:				; CODE XREF: sub_1E9E+36p
		jp	UnpauseMusic
; End of function j_UnpauseMusic


; =============== S U B	R O U T	I N E =======================================

; Attributes: thunk

j_FadeOut:				; CODE XREF: sub_1CED+3D6p
		jp	FadeOut
; End of function j_FadeOut

; ---------------------------------------------------------------------------
		jp	LoadSFX

; =============== S U B	R O U T	I N E =======================================

; Attributes: thunk

j_PlayMusic:				; CODE XREF: sub_2D7+Bp
		jp	PlayMusic
; End of function j_PlayMusic


; =============== S U B	R O U T	I N E =======================================

; Attributes: thunk

j_PlaySFX:				; CODE XREF: sub_2FE+8p
		jp	PlaySFX
; End of function j_PlaySFX


; =============== S U B R O U T I N E =======================================
; from Phantasy Star (sub_3A4)
; with comments from http://www.smspower.org/Development/FMChipDetection
ChipEnableOfs = 0DFF0h
FM_Detection:				; CODE XREF: BANK0:00CEp
		ld	a, (ChipEnableOfs)
		or	04h		; Disable I/O chip
		out	(3Eh), a
		
		ld	bc, 700h	; Counter (7 -> b), plus 0 -> c
loc_3AE:				; CODE XREF: sub_3A4:loc_3BCj
		ld	a, b
		and	01h
		out	(0F2h), a	; Output data in the form %00000??1 FM chip lots of times
		ld	e, a
		
		in	a, (0F2h)
		and	07h		; Ignore high 5 bits,
		cp	e		; check low 3 are the same as what was written
		jr	nz, loc_3BC
		inc	c		; c = # of times the test was passed
loc_3BC:				; CODE XREF: sub_3A4+15j
		djnz	loc_3AE
		
		ld	a, c
		cp	07h		; Check test was passed 7 times out of 7
		jr	z, loc_3C4
		xor	a		; If not, result is 0

loc_3C4:				; CODE XREF: sub_3A4+1Dj
		and	01h		; If so, result is 1
		out	(0F2h), a	; Output result to FM chip
		ld	e, a
		rrca
		or	e		; set FM Enable to either 00 (not detected) or 81 (FM detected + enabled)
		ld	(0DC00h), a	; Store result
		
		ld	a, (ChipEnableOfs)
		out	(3Eh), a	; Turn I/O chip back on
		ret
; End of function sub_3A4



; =============== S U B	R O U T	I N E =======================================


LoadMusic:				; CODE XREF: BANK1:4003j PlayMusic+Fp
		push	af
		push	bc
		push	de
		push	hl
		push	ix
		ld	c, l		; save Song Base Address
		ld	b, h
		
		ld	e, 4		; load 4 PSG tracks
		
		ld	a, (0DC00h)
		rra			; check FM mode (Bit 0 -> Carry)
		jr	nc, lm_trkselect
		
		; FM Mode - check for unfixed file
		ld	hl, 0008h
		add	hl, bc
		ld	a, (hl)
		inc	hl
		or	(hl)		; Is the Track 5 pointer 0?
		ld	l, c
		ld	h, b
		jr	z, lm_trkselect	; not yet fixed file - 4 tracks only
		
		ld	e, 7		; load 7 FM tracks (6x Melody + 1x Drums)
lm_trkselect:
		ld	a, e
		ld	(PlaybackMode), a	; save number of tracks to load
		ld	ix, Trk0DataPtr
loc_4026:				; CODE XREF: LoadMusic+20j
		ld	e, (hl)		; get Track Offset
		inc	hl
		ld	d, (hl)
		inc	hl
		ex	de, hl
		add	hl, bc		; make absolute
		ld	(ix+00h), l	; save to Trk#DataPtr
		inc	ix
		ld	(ix+00h), h
		inc	ix
		ex	de, hl
		dec	a
		jp	nz, loc_4026	; loop A times
		
		; ensure that the PSG is silenced
		ld	a, 9Fh
lm_psgoffloop:
		out	(7Fh), a
		add	a, 20h
		jp	nc, lm_psgoffloop
		
		ld	a, (0DC00h)
		rra			; check FM mode (Bit 0 -> Carry)
		jr	c, lm_fminit
		
lm_psginit:
		ld	ix, MusTrk0
		ld	de, TrackSize
		ld	a, 80h
lm_baseptr_psg:
		ld	(ix+20h), c		; write Song Base Pointer to all Music Tracks
		ld	(ix+21h), b
		
		ld	(ix+00h), a
		add	a, 10h
		ld	(ix+01h), a
		add	ix, de
		add	a, 10h
		jp	nz, lm_baseptr_psg
		
		jp	lm_trkinit
		
lm_fminit:
		ld	ix, MusTrk0
		ld	de, TrackSize
		ld	a, (PlaybackMode)
		neg
		ld	l, a	; make L run from (TrkCount * -1) to 0
		;ld	a, 20h
		ld	a, 20h+7
		add	a, l
lm_baseptr_fm:
		ld	(ix+20h), c		; write Song Base Pointer to all Music Tracks
		ld	(ix+21h), b
		
		ld	(ix+00h), a
		add	a, 10h
		ld	(ix+01h), a
		sub	a, 0Fh
		add	ix, de
		inc	l
		jp	nz, lm_baseptr_fm
		
		;jr	lm_trkinit
		
lm_trkinit:
		ld	a, (0DC00h)
		or	a
		call	m, SilenceFM	; is FM chip was detected, reset it
		
		ld	ix, MusTrk0
		ld	hl, Modulat_Null
		ld	de, TrackSize
		ld	a, (PlaybackMode)
		ld	b, a
		ld	c, 00h
lm_trkinitloop:
		ld	(ix+02h), 01h	; initialize Tick Step
		ld	(ix+03h), d
		ld	(ix+08h), d	; reset Frequency Detune
		ld	(ix+09h), d
		ld	(ix+14h), l
		ld	(ix+15h), h
		ld	(ix+16h), d	; reset Transpose (ensure Melody mode)
		ld	(ix+17h), c	; set Track ID
		ld	(ix+18h), 82h	; mark as 'active' and 'playing'
		ld	(ix+1Ch), d
		ld	(ix+1Dh), d
		ld	(ix+26h), TrackSize	; initialize Loop Stack
		ld	(ix+27h), d	; reset Master Loop Address
		ld	(ix+28h), d
		
		ld	a, (ix+00h)
		cp	26h
		jr	nz, lm_til_nodrum
		
		ld	(ix+06h), d
		ld	(ix+07h), 0Fh	; Bass Drum: F
;		ld	(ix+08h),09Ah	; Snare Drum: A, Hi-Hat: 9
;		ld	(ix+09h),0EBh	; Cymbal: B, Tom: E
		ld	(ix+08h),0CFh	; Snare Drum: F, Hi-Hat: C
		ld	(ix+09h),0EDh	; Cymbal: D, Tom: E
		ld	(ix+16h), 80h	; Transpose = 80h -> Drum Mode
		
lm_til_nodrum:
		add	ix, de
		inc	c
		djnz	lm_trkinitloop
		
		ld	a, 7
		sub	c
		jr	z, loc_405D
		ld	b, a
lm_trkclearloop:
		; ensure that all other tracks get disabled
		ld	(ix+00h), d
		ld	(ix+01h), d
		ld	(ix+18h), d
		add	ix, de
		djnz	lm_trkclearloop
		
loc_405D:				; CODE XREF: LoadMusic+3Dj
		ld	hl, 1
		ld	(TickMult), hl	; assume a default tempo of 1
		ld	(TickDiv1), hl
		ld	(TickDiv2), hl
		xor	a
		ld	(CurSFXPrio), a
		ld	(PlaybackMode), a
		;ld	(SFXTrk+18h), a	; mark SFX track as 'disabled'
		
		pop	ix
		pop	hl
		pop	de
		pop	bc
		pop	af
		ret
; End of function LoadMusic

; ---------------------------------------------------------------------------
; Note: Format is address, 16-bit data
;TrkInitVals1:	Group2_2	MusTrk0+27h, 0	; DATA XREF: LoadMusic+23o
;		Group2_2	MusTrk1+27h, 0	; reset Master Loop Address
;		Group2_2	MusTrk2+27h, 0
;		Group2_2	MusTrk3+27h, 0
;		Group2_2	MusTrk0+02h, 1	; initialize Tick Step
;		Group2_2	MusTrk1+02h, 1
;		Group2_2	MusTrk2+02h, 1
;		Group2_2	MusTrk3+02h, 1
;		Group2_2	MusTrk0+14h, Modulat_Null	; reset Modulation Pointer
;		Group2_2	MusTrk1+14h, Modulat_Null
;		Group2_2	MusTrk2+14h, Modulat_Null
;		Group2_2	MusTrk3+14h, Modulat_Null
;		Group2_2	MusTrk0+1Ch, 0
;		Group2_2	MusTrk1+1Ch, 0
;		Group2_2	MusTrk2+1Ch, 0
;		Group2_2	MusTrk3+1Ch, 0
;		Group2_2	MusTrk0+08h, 0	; reset Frequency Detune
;		Group2_2	MusTrk1+08h, 0
;		Group2_2	MusTrk2+08h, 0
;		Group2_2	MusTrk3+08h, 0
;		dw 0FFFFh
;TrkInitVals2:	Group2_1	MusTrk0+00h,  80h	; DATA XREF: LoadMusic:loc_404Do
;		Group2_1	MusTrk0+01h,  90h	; set Channel/Volume Bits
;		Group2_1	MusTrk1+00h, 0A0h
;		Group2_1	MusTrk1+01h, 0B0h
;		Group2_1	MusTrk2+00h, 0C0h
;		Group2_1	MusTrk2+01h, 0D0h
;		Group2_1	MusTrk3+00h, 0E0h
;		Group2_1	MusTrk3+01h, 0F0h
;		Group2_1	MusTrk0+18h, 2	; mark as 'in use'
;		Group2_1	MusTrk1+18h, 2
;		Group2_1	MusTrk2+18h, 2
;		Group2_1	MusTrk3+18h, 2
;		Group2_1	MusTrk0+17h, 0	; set Track ID
;		Group2_1	MusTrk1+17h, 1
;		Group2_1	MusTrk2+17h, 2
;		Group2_1	MusTrk3+17h, 3
;		Group2_1	MusTrk0+26h, TrackSize	; initialize Loop Stack
;		Group2_1	MusTrk1+26h, TrackSize
;		Group2_1	MusTrk2+26h, TrackSize
;		Group2_1	MusTrk3+26h, TrackSize
;		dw 0FFFFh
PSGMuteVals:	db 9Fh, 0BFh, 0DFh, 0FFh ; DATA XREF: StopAllSound+33o
Modulat_Null:	db 7 dup (00h)

; =============== S U B	R O U T	I N E =======================================


StopAllSound:				; CODE XREF: j_StopAllSoundj
					; UpdateSound+B3p
		push	af
		push	bc
		push	de
		push	hl
		
		ld	hl, SFXTrk+18h
		res	1, (hl)		; AND 0FDh - Stop SFX Track
		
		ld	hl, MusTrk0+18h
		ld	de, TrackSize
		ld	b, 7		; 7 FM tracks (or 4 PSG tracks, but that covers it)
sas_trkloop:
		res	1, (hl)		; Stop Track
		add	hl, de
		djnz	sas_trkloop
		
;		ld	a, (MusTrk0+18h) ; Trk0+28 - Track Flags
;		and	0FDh		; Stop Track 0
;		ld	(MusTrk0+18h), a
		
;		ld	a, (MusTrk1+18h) ; Trk1+28 - Track Flags
;		and	0FDh		; Stop Track 1
;		ld	(MusTrk1+18h), a
		
;		ld	a, (MusTrk2+18h) ; Trk2+28 - Track Flags
;		and	0FDh		; Stop Track 2
;		ld	(MusTrk2+18h), a
		
;		ld	a, (MusTrk3+18h) ; Trk3+28 - Track Flags
;		and	0FDh		; Stop Track 3
;		ld	(MusTrk3+18h), a
		
;		ld	a, (SFXTrk+18h) ; Trk4+28 - Track Flags
;		and	0FDh		; Stop Track 4
;		ld	(SFXTrk+18h), a
		
		xor	a
		ld	(CurSFXPrio), a	; reset SFX Priority
		
		ld	b, 4		; 4 channels
		ld	c, 7Fh		; PSG output port
		ld	hl, PSGMuteVals
		otir			; mute all PSG channels
		
		ld	a, (0DC00h)
		rla			; FM available? (Bit 7 -> Carry)
		jr	nc, sas_finish	; no FM chip found - exit
		
		call	SilenceFM
		
		; --- set FM Drum Frequency ---
		ld	hl, FMDrumFreqs
		ld	b, 2*3
sas_init_fmdrum:
		YMWait_Data
		ld	a, (hl)
		out	(0F0h), a
		inc	hl
		ld	a, (hl)
		YMWait_Reg	6+7
		out	(c), a
		inc	hl
		djnz	sas_init_fmdrum
		
sas_finish:
		ld	a, (PlaybackMode)
		and	0F7h		; disable Fading (equals RES #3, A)
		ld	(PlaybackMode), a
		
		pop	hl
		pop	de
		pop	bc
		pop	af
		ret
; End of function StopAllSound

SilenceFM:
		ld	c, 0F1h
		ld	d, 00h
		
		ld	b, 6	; don't overwrite the drum notes (6-8)
		ld	a, 10h		; Register 2x - Key On/Off
sas_mute_fmloop1:
		out	(0F0h), a	; write Register
		inc	a
		YMWait_Reg	4
		out	(c), d		; write Data (Key Off)
		YMWait_Data
		djnz	sas_mute_fmloop1
		
		ld	b, 6	; don't overwrite the drum notes (6-8)
		ld	a, 20h		; Register 2x - Key On/Off
sas_mute_fmloop2:
		out	(0F0h), a	; write Register
		inc	a
		YMWait_Reg	4
		out	(c), d		; write Data (Key Off)
		YMWait_Data
		djnz	sas_mute_fmloop2
		
		ld	a, 0Eh
		out	(0F0h), a	; Rhythm Section
		YMWait_Reg	7
		ld	a, 20h
		out	(c), a		; Rhythm mode on, all drums off
		ret

FMDrumFreqs:
		db	16h, 20h, 26h, 05h	; 520h
		;db	17h, 50h, 27h, 05h	; 550h
		;db	18h,0C0h, 28h, 01h	; 1C0h
		db	17h,0B0h, 27h, 01h	; 1B0h
		db	18h, 80h, 28h, 01h	; 301h = 180h

WaitForYM:	; from Phantasy Star
		push	hl		; This doesn't really "wait" for the YM2413.
		pop	hl		; It just causes a small delay that's enough for the chip to process the data.
		ret
; End of function WaitForYM


; =============== S U B	R O U T	I N E =======================================


LoadSFX:				; CODE XREF: BANK1:400Fj PlaySFX+11p
		push	af
		push	de
		push	hl
		ld	e, a
		ld	a, (CurSFXPrio)	; get current SFX Priority
		and	a
		jr	z, loc_417E	; SFX Prio == 0 -> skip check
		cp	e
		jr	c, loc_41D9	; new Priority < old Priority -> return

loc_417E:				; CODE XREF: LoadSFX+8j
		ld	a, e
		ld	(CurSFXPrio), a		; write Sound Priority
		ld	(SFXTrk+20h), hl	; write Track Base Pointer
		ld	a, (SFXTrk+01h)		; get Volume Bits
		or	0Fh			; Volume 0F (silent)
		out	(7Fh), a		; write to PSG chip
		ld	a, (hl)
		ld	(OverriddenTrk), a
		inc	hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ld	(SFXTrk+22h), de
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ld	(TickDivSFX), de
		inc	hl
		ld	(SFXTrkDataPtr), hl
		ld	hl, PSGChnBits
		add	a, a
		ld	e, a
		ld	d, 0
		add	hl, de
		ld	a, (hl)
		ld	(SFXTrk+00h), a	; set Channel Frequency	Bits (80/A0/C0/E0)
		inc	hl
		ld	a, (hl)
		ld	(SFXTrk+01h), a	; set Channel Volume Bits (90/B0/D0/F0)
		ld	hl, Modulat_Null
		ld	(SFXTrk+14h), hl	; reset Modulation Pointer
		ld	hl, 0
		ld	(SFXTrk+27h), hl	; reset Master Loop Address
		ld	(SFXTrk+1Ch), hl	; reset Modulation Freq. Delta [current value]
		ld	(SFXTrk+08h), hl	; reset Frequency Detune
		ld	a, 80h
		ld	(SFXTrk+17h), a	; Track ID = 80
		inc	hl
		ld	(SFXTrk+02h), hl
		ld	a, TrackSize
		ld	(SFXTrk+26h), a	; set Loop Stack Pointer
		ld	a, 82h
		ld	(SFXTrk+18h), a	; set 'is in use' and 'active' Bits

loc_41D9:				; CODE XREF: LoadSFX+Bj
		pop	hl
		pop	de
		pop	af
		ret
; End of function LoadSFX

; ---------------------------------------------------------------------------
; Order: Ch 1 Frequency, Ch 1 Volume, Ch 2 Freq, Ch 2 Vol, ...
PSGChnBits:	db 80h, 90h, 0A0h, 0B0h, 0C0h, 0D0h, 0E0h, 0F0h	; DATA XREF: LoadSFX+34o

; =============== S U B	R O U T	I N E =======================================


UnpauseMusic:				; CODE XREF: j_UnpauseMusicj
		push	af
		push	bc
		push	de
		push	ix
		
		ld	ix, MusTrk0
		ld	de, TrackSize
		
		ld	a, (0DC00h)
		rla			; FM available? (Bit 7 -> Carry)
		ld	b, 4		; PSG - 4 tracks
		jr	nc, upm_trkloop
		ld	b, 7		; FM - 7 tracks
upm_trkloop:
		;ld	a, (ix+01h)
		;or	a
		bit	7, (ix+18h)
		jr	z, upm_trkloopskip	; empty track - skip
		
		set	1, (ix+18h)	; set 'is in use' Bit
		ld	a, (ix+24h)
		ld	(ix+05h), a	; refresh Fade Ticks
upm_trkloopskip:
		add	ix, de
		djnz	upm_trkloop
		
		xor	a
		ld	(PlaybackMode), a	; reset Playback Mode
		
		pop	ix
		pop	de
		pop	bc
		pop	af
		ret
; End of function UnpauseMusic


; =============== S U B	R O U T	I N E =======================================


FadeOut:				; CODE XREF: j_FadeOutj
		push	af
		push	hl
		ld	(FadeTickDec), hl
		ld	hl, PlaybackMode
		set	3, (hl)		; enable Fading
		ld	hl, 1000h
		ld	(FadeTicks), hl
		pop	hl
		pop	af
		ret
; End of function FadeOut


; =============== S U B	R O U T	I N E =======================================


UpdateSound:				; CODE XREF: j_UpdateSoundj
		; Labyrinth Zone doesn't trigger it, so I don't need that safety.
	;	; Interrupts are enabled (in order to make the underwater palette change),
	;	; so prevent it from re-entering if the sound driver takes too long
	;	ld	hl, 0DC00h
	;	bit	3, (hl)
	;	ret	nz
	;	;jr	nz, UpdateSound-1
	;	set	3, (hl)
		
		ld	a, (0DC03h)
		or	a
		jr	z, us_notrigger
		dec	a
		call	PlayMusic
		xor	a
		ld	(0DC03h), a
us_notrigger:
		
	if 1
		; --- track update loop ---
		ld	a, (0DC00h)
		rla			; FM available? (Bit 7 -> Carry)
		jr	c, usnd_fm	; yes - jump
usnd_psg:
		ld	b, 4
		jp	usnd_trkupdate
usnd_fm:
		ld	b, 7
		;jr	usnd_trkupdate
		
usnd_trkupdate:
		ld	ix, MusTrk0
		ld	hl, Trk0DataPtr
usnd_trk_loop:
		push	bc
		push	hl
		ld	e, (hl)			; load Data Pointer
		inc	hl
		ld	d, (hl)
		ld	bc, (TickDiv1)		; load Track Tempo
		call	UpdateTrack
		pop	hl
		ld	(hl), e			; save Data Pointer
		inc	hl
		ld	(hl), d
		inc	hl
		ld	de, TrackSize
		add	ix, de
		pop	bc
		djnz	usnd_trk_loop
		
usnd_set_ptrs:
		ld	ix, Chn0TrkPtr
		ld	hl, MusTrk0
		ld	de, TrackSize
		ld	b, 4
usnd_ram_ptr_loop:
		ld	(ix+00h), l	; save RAM Pointer
		ld	(ix+01h), h
		inc	ix
		inc	ix
		add	hl, de
		djnz	usnd_ram_ptr_loop
	else
		; --- track update unrolled ---
		; For some reason the unrolled loop causes the lag counter in BizHawk
		; to increase FASTER than using the normal loop.
usnd_TrkPtr	:= MusTrk0
usnd_DataPtr	:= Trk0DataPtr
usnd_ProcPtr	:= Chn0TrkPtr
	  rept	4
		ld	ix, usnd_TrkPtr
		ld	(usnd_ProcPtr), ix
		ld	de, (usnd_DataPtr)
		ld	bc, (TickDiv1)
		call	UpdateTrack
		ld	(usnd_DataPtr), de
usnd_TrkPtr	:= usnd_TrkPtr + TrackSize
usnd_DataPtr	:= usnd_DataPtr + 2
usnd_ProcPtr	:= usnd_ProcPtr + 2
	  endm
	  rept	3
		ld	ix, usnd_TrkPtr
		ld	de, (usnd_DataPtr)
		ld	bc, (TickDiv1)
		call	UpdateTrack
		ld	(usnd_DataPtr), de
usnd_TrkPtr	:= usnd_TrkPtr + TrackSize
usnd_DataPtr	:= usnd_DataPtr + 2
	  endm
	endif
		
usnd_sfx:
		ld	ix, SFXTrk		; DCDA - SFX Track
		ld	de, (SFXTrkDataPtr)
		ld	bc, (TickDivSFX)
		call	UpdateTrack
		ld	(SFXTrkDataPtr), de
		
		bit	1, (ix+18h)
		jr	z, loc_42BF		; SFX track not in use - skip
		ld	hl, Chn0TrkPtr
		ld	de, SFXTrk
		ld	a, (OverriddenTrk)	; get 'Overridden Track' number
		add	a, a			; make it an index (16-bit elements)
		ld	c, a
		ld	b, 0
		add	hl, bc			; HL = &TrackAddrs[A]
		ld	(hl), e			; set address to SFX track
		inc	hl
		ld	(hl), d
; Now we process all 4 channels.
; We load one of the 4 addressed (DC14..1A) and process the respective track.
; One of the 4 addresses can point to an SFX track. (see the code above)

loc_42BF:				; CODE XREF: UpdateSound+73j
		ld	a, (0DC00h)
		rla			; FM available? (Bit 7 -> Carry)
		jr	nc, usnd_procpsg
		
		ld	b, 7
		ld	ix, MusTrk0
usnd_procfmloop:
		push	bc
		call	ProcessTrack_FM
		ld	de, TrackSize
		add	ix, de
		pop	bc
		djnz	usnd_procfmloop
		
usnd_procpsg:
		ld	ix, (Chn0TrkPtr)	; load Channel 0 Track RAM
		call	ProcessTrack
		ld	ix, (Chn1TrkPtr)	; load Channel 1 Track RAM
		call	ProcessTrack
		ld	ix, (Chn2TrkPtr)	; load Channel 2 Track RAM
		call	ProcessTrack
		ld	ix, (Chn3TrkPtr)	; load Channel 3 Track RAM
		call	ProcessTrack
		
	;	ld	hl, 0DC00h	; allow re-entering of the UpdateSound routine
	;	res	3, (hl)
		
		ld	a, (PlaybackMode)
		and	8
		ret	z			; not fading - return
		ld	hl, (FadeTicks)		; get remaining Fade Ticks
		ld	bc, (FadeTickDec)	; get Fade Tick Decrement
		and	a			; set "carry" flag to 0
		sbc	hl, bc			; HL -= BC (and refresh all flags)
		;jr	nc, loc_42F0
		call	c, StopAllSound
;loc_42F0:				; CODE XREF: UpdateSound+B1j
		ld	(FadeTicks), hl
		ret
; End of function UpdateSound


; =============== S U B	R O U T	I N E =======================================


UpdateTrack:				; CODE XREF: UpdateSound+Cp
					; UpdateSound+23p ...
		bit	1, (ix+18h)
		ret	z		; not in use - return
		ld	l, (ix+02h)	; subtract Frame Ticks from remaining Ticks until next event
		ld	h, (ix+03h)	; (TrkRAM+02) -= BC
		and	a		; set "carry" flag to 0
		sbc	hl, bc		; HL -= BC (and refresh all flags)
		ld	(ix+02h), l
		ld	(ix+03h), h
		jr	z, ut_proctrk
		;jp	nc, UpdTrk_Return ; If the remaining Ticks are still positive, return.
		ret	nc
ut_proctrk:
TrackReadLoop:				; CODE XREF: UpdateTrack+14j
					; ProcessTrack+138j ...
		ld	a, (de)		; Read Note/Command
		cp	0E0h
		jp	nc, DoCommand	; E0-FF - Command
		
DoNote_Main:
		and	0Fh		; get lower nibble
		jr	z, DoRest	; 00 - Rest
		cp	0Eh		; 0E - Hold previous Note
		jp	z, DoNoteLen	; skip note reading
		
		dec	a
		add	a, (ix+16h)	; add Transpose
		jp	m, DoNoiseNote
		jp	DoNote
		
		;cp	70h		; 00-6F - normal Note
		;jr	c, DoNote
		;cp	7Fh		; 70-7E - Noise Note
		;jr	nz, DoNoiseNote
		
DoRest:
		;ld	(ix+1Eh), 00h	; 7F - Rest (set 'effective volume' to 0 min)
		ld	(ix+1Eh), a	; "A" happens to be 0
		set	5, (ix+18h)	; mark as "require to send frequency"
		
		; DoNoteLen should handle that correctly
;		bit	7, (ix+00)	; check FM mode
;		jp	nz, DoNoteLen	; PSG - jump now
		
;		ld	a, (ix+00h)
;		out	(0F0h), a	; Register: 2x (Key On/Off)
;		YMWait_Reg	19
;		ld	a, (ix+07h)	; get Octave
;		out	(0F1h), a	; Data 00 - Key Off
		
		jp	DoNoteLen

; ---------------------------------------------------------------------------

DoNoiseNote:				; CODE XREF: UpdateTrack+24j
		set	5, (ix+18h)	; mark as "require to send frequency"
		bit	7, (ix+00h)	; check FM mode
		jr	z, DoDrumFM
		
		push	de
		push	ix
		pop	hl		; HL = Track RAM Pointer
		ld	bc, 0Eh
		add	hl, bc
		ex	de, hl		; DE = TrkRAM+0E
		;and	0Fh		; get lower nibble (Note)
		and	01h	; we have only 2 Noise Drum sounds
		add	a, a
		add	a, a
		add	a, a
		ld	l, a
		ld	h, 0
		;add	hl, hl
		;add	hl, hl
		;add	hl, hl		; HL = (A * 8)
		ld	bc, NoiseNoteVals
		add	hl, bc		; HL = &NoiseNoteVals[Note] (8 bytes per element)
		ld	a, (hl)
		ld	(ix+25h), a	; TrkRAM+25 = HL[0]
		inc	hl
		ldi			; TrkRAM+0E = HL[1]
		ldi
		ldi
		ldi
		ldi
		ldi			; TrkRAM+13 = HL[6]
		pop	de
		jp	ResetModVals
; ---------------------------------------------------------------------------

DoDrumFM:
		and	03h
		ld	hl, FMDrumVals
		ld	b, 00h
		ld	c, a
		add	hl, bc
		ld	a, (hl)
		ld	(ix+06h), a
		
		;jp	ResetModVals
		ld	(ix+1Eh), 10h
		jp	DoNoteLen
; Drums:
;	BD - 10, SD - 08, TOM - 04, CYM - 02, HH - 01
; Recommended Frequency:
;	16 20, 26 05
;	17 50, 27 05
;	18 C0, 28 01
; Volume:
;	BD - 36 (low)
;	SD - 37 (low)
;	TOM - 38 (high)
;	CYM - 38 (low)
;	HH - 37 (high)

DoNote:
		set	5, (ix+18h)	; mark as "require to send frequency"
		bit	7, (ix+00h)	; check FM mode
		jr	nz, DoNote_PSG
		
DoNote_FM:
		ld	b, -1
		ld	c, 12
DoNote_OctChkFM:
		sub	c
		inc	b
		jp	nc, DoNote_OctChkFM
		add	a, c
		
		add	a, a		; make it an index for 16-bit array
		ld	c, a
		
		; prevent octave overflow
		ld	a, b
		cp	08h
		jr	c, DoNote_OctOK
		ld	a, 07h
DoNote_OctOK:
		add	a, a		; the Octave is stored in bits 1-3
		ld	(ix+1Fh), a	; and save Octave to TrkRAM+1F
		
		ld	hl, FMFreqVals
		;add	a, a		; make it an index for 16-bit array
		ld	b, 0
		;ld	c, a
		add	hl, bc		; HL = &PSGFreqVals[Note]
		ld	c, (hl)		; get Frequency value and save it to TrkRAM+06/07
		ld	(ix+06h), c
		inc	hl
		ld	c, (hl)
		ld	(ix+07h), c
		
		bit	0, (ix+18h)
		jp	nz, DoNoteLen
		
		ld	a, (ix+00h)
		out	(0F0h), a	; Register 2x: Frequency MSB / Key On/Off
		YMWait_Reg	4+19
		ld	a, c
		or	(ix+1Fh)
		out	(0F1h), a	; Data: Frequency with Key Off
		jp	ResetModVals

DoNote_PSG:					; CODE XREF: UpdateTrack+20j
		ld	b, -1-3		; The PSG begins at octave 3.
		ld	c, 12
DoNote_OctCheck:
		sub	c
		inc	b
		jp	nc, DoNote_OctCheck
		add	a, c
		bit	7, b		; negative?
		jr	z, DoNote_OctP
		
DoNote_OctN:
		ld	b, 0		; enforce Octave 0
		add	a, 3		; make A1..B1 (9..11) -> A0..B0 (12..14)
DoNote_OctP:
		ld	(ix+1Fh), b	; and save Octave to TrkRAM+1F
		
		ld	hl, PSGFreqVals
		add	a, a		; make it an index for 16-bit array
		ld	b, 0
		ld	c, a
		add	hl, bc		; HL = &PSGFreqVals[Note]
		ld	a, (hl)		; get Frequency value and save it to TrkRAM+06/07
		ld	(ix+06h), a
		inc	hl
		ld	a, (hl)
		ld	(ix+07h), a
		;ld	a, (de)		; read byte again
		;rrca
		;rrca
		;rrca
		;rrca
		;and	0Fh		; get higher nibble (Octave)
		;ld	(ix+1Fh), a	; and save to TrkRAM+1F
		bit	0, (ix+18h)
		jr	nz, DoNoteLen

ResetModVals:				; CODE XREF: UpdateTrack+54j
		ld	l, (ix+14h)	; load Modulation Pointer
		ld	h, (ix+15h)
		
		ld	a, (hl)
		ld	(ix+19h), a	; reload Initial Mod Delay
		inc	hl
		ld	a, (hl)
		ld	(ix+1Ah), a	; reload Mod Step Delay
		inc	hl
		ld	a, (hl)
		srl	a		; cur Mod Steps = init Mod Steps / 2
		ld	(ix+1Bh), a	; (for 0 -> 1, ModSteps is +1 <-> -1)
		inc	hl
		
		ld	c, (ix+00h)
		bit	7, c		; check FM mode
		jr	nz, rmv_dodelta
		inc	hl		; FM mode - skip the PSG delta
		inc	hl
rmv_dodelta:
		ld	a, (hl)
		ld	(ix+1Ch), a	; reload Frequency Delta (16-bit value)
		inc	hl
		ld	a, (hl)
		ld	(ix+1Dh), a
		
		xor	a
		ld	(ix+0Ah), a	; reset Modulation Frequency (16-bit value)
		ld	(ix+0Bh), a
		ld	(ix+0Dh), a	; reset ADSR Envelope State (Attack Phase)
		ld	(ix+0Ch), a	; reset Envelope Level (min. volume)
		res	4, (ix+18h)
		ld	(ix+1Eh), 0Fh	; set 'effective Volume' to max
		bit	7, c		; check FM mode
		jr	nz, DoNoteLen
		inc	(ix+1Eh)	; FM mode - set to 10h (Key On bit)

DoNoteLen:				; CODE XREF: UpdateTrack+2Aj
					; UpdateTrack+78j
		ld	a, (de)
		inc	de
DoNote_CalcDelay:
		rrca
		rrca
		rrca
		rrca
		and	0Fh		; get higher nibble (Delay)
		
		cp	0Dh
		jr	nc, DoNote_DlyExtra
		
		ld	hl, DELAY_TBL
		ld	b, 00h
		ld	c, a
		add	hl, bc
		ld	a, (hl)		; A = DELAY_TBL[c]
		jp	DoNote_DlyFin
		
DoNote_DlyExtra:
		ld	a, (de)		; get separate Note Length
		inc	de
DoNote_DlyFin:
		srl	a		; divide by 2

loc_43A8:				; CODE XREF: UpdateTrack+AFj
		push	de		; save Track Pointer
		;ld	c, a
		ld	b, a		; CalcTickTime_Opt uses B as multiplicator
		ld	l, (ix+22h)	; load Track Tick Multiplier
		ld	h, (ix+23h)
		ld	a, l
		or	h
		jr	nz, loc_43B7
		ld	hl, (TickMult)	; was 0 - load Global Tick Multiplier (used by SFX)

loc_43B7:				; CODE XREF: UpdateTrack+BEj
		;call	CalcTickTime	; HL = (HL * C)
		call	CalcTickTime_Opt	; the Tick Multiplier is always quite small, so this shoule be faster
		pop	de		; restore Track Pointer
		ld	a, l		; (IX+02) += HL
		add	a, (ix+02h)
		ld	(ix+02h), a
		ld	a, h
		adc	a, (ix+03h)
		ld	(ix+03h), a
		
		res	0, (ix+18h)
		
		; TODO: Move this somewhere else
		ld	a, (ix+00h)
		or	a		; check FM mode
		ret	m		; 80-FF - PSG Mode, return
		
		bit	5, (ix+18h)
		ret	z
		res	5, (ix+18h)
		
		bit	7, (ix+16h)
		jr	nz, UpdTrk_FMDrum
		
		ld	b, a
		ld	c, 0F0h
		;ld	a, (ix+00h)
		sub	a, 10h
		out	(c), a		; Register 1x: Frequency LSB
		YMWait_Reg	19
		ld	a, (ix+06h)	; raw Frequency LSB
		add	a, (ix+08h)	; Frequency Detune LSB
		out	(0F1h), a	; Data: Frequency
		;YMWait_Data
		
		; use the YM2413 delay time for something useful.
		ld	a, (ix+07h)	; raw Frequency MSB
		adc	a, (ix+09h)	; Frequency Detune MSB
		or	(ix+1Fh)
		
		out	(c), b		; Register 2x: Key On/Off
		;YMWait_Reg	19+19+19
		YMWait_Reg	19
		or	(ix+1Eh)
		out	(0F1h), a	; Data: Frequency with Key On/Off (depending on +1Eh)

;UpdTrk_Return:				; CODE XREF: UpdateTrack+16j
		;res	0, (ix+18h)
		ret
; End of function UpdateTrack

UpdTrk_FMDrum:
		ld	a, 0Eh
		out	(0F0h), a	; Register 0E: Rhythm
		YMWait_Reg	7
		ld	a, 20h		; Rhythm Mode on, all Drums off
		out	(0F1h), a	; turn all Drums off first
		
		bit	4, (ix+1Eh)
		ret	z
		
		;YMWait_Data	; all the stuff takes 20+7+19+7 = 53 cycles
		ld	a, (ix+06h)
		or	20h		; add Rhythm Mode bit in
		out	(0F1h), a
		ret

DELAY_TBL:
	db	192,  96,  48,  24,  12,   6,   3
	db	      64,  32,  16,   8,   4,   2

; ---------------------------------------------------------------------------
; The bytes are:
; 00 - Noise Mode (TrkRAM+25)
; 01 - Attack Rate (TrkRAM+0E)
; 02 - Decay 1 Rate (TrkRAM+0F)
; 03 - Decay 1 Level (TrkRAM+10)
; 04 - Decay 2 Rate (TrkRAM+11)
; 05 - Decay 2 Level (TrkRAM+12)
; 06 - Sustain Rate (TrkRAM+13)
; 07 - padding

NoiseNoteVals:				; DATA XREF: UpdateTrack+3Eo
		db	05h,0FFh,0BEh, 0Ah, 04h, 05h, 02h, 0	; Bass Drum
		db	05h,0E6h, 24h, 5Ah, 14h, 28h, 08h, 0	; Snare Drum

FMDrumVals:
		db	15h	; BD+Tom+HH
		db	09h	; SD+HH
		db	16h	; BD+Tom+Cym
		db	0Ah	; SD+Cym

; =============== S U B	R O U T	I N E =======================================


ProcessTrack_FM:
		bit	1, (ix+18h)
		ret	z		; not in use - return
		bit	7, (ix+00h)
		ret	nz		; PSG channel - return
		
		ld	a, (ix+00h)		; get Channel Frequency Bits
		cp	26h			; is Drum Channel?
		call	nz, DoModulation	; no - do Modulation
		
		ld	a, (PlaybackMode)
		and	8
		ret	z		; not fading - return
		jp	CalcFadeVol

ProcessTrack:				; CODE XREF: UpdateSound+89p
					; UpdateSound+90p ...
		bit	1, (ix+18h)
		ret	z		; not in use - return
		bit	7, (ix+00h)
		ret	z		; not a PSG channel - return
		ld	a, (ix+0Dh)	; get Envelope State
; Note: The ADSR envelope of this sound driver has 2 decay phases and
;       no real release phase. (A Note Off event causes instant silence.)
		and	a
		jp	z, ADSREnv_Atk	; State 00 - Attack Phase
		dec	a
		jp	z, ADSREnv_Dec1	; State 01 - Decay 1 Phase
		dec	a
		jp	z, ADSREnv_Dec2	; State 02 - Decay 2 Phase
		dec	a
		jp	z, ADSREnv_Sus	; State 03 - Sustain Phase
					; State 04 - keep current level

DoTrkSoundOut:				; CODE XREF: ProcessTrack+175j
						; ProcessTrack+17Bj ...
		ld	a, (ix+00h)		; get Channel Frequency Bits
		cp	0E0h			; is Noise Channel?
		jr	nz, DoModulation	; no - jump
		
		ld	c, (ix+25h)		; get Channel Noise Mode
		ld	a, (CurNoiseMode)	; get Global Noise Mode
		cp	c
		jp	z, SendVolume		; equal - skip
		ld	a, c
		ld	(CurNoiseMode), a	; else set Global = Channel Noise Mode
		or	0E0h			; add PSG Noise Bits
		out	(7Fh), a		; and write to PSG chip
		jp	SendVolume
; ---------------------------------------------------------------------------
; Notes about Modulation:
; After a note is played, x frames pass before the Modulation starts to take effect.
; This is the initial Modulation Delay.
;
; Then the frequency of the current tone is modified by a certain amount. (Frequency Delta)
; This happens every x frames. (Modulation Tick Delay, a.k.a. Modulation Speed)
; After the frequency was changed a certain amount of times, the Freq. Delta is inverted. (Step Count)
; When the frequency is inverted, the frequency is not modified.
;
;                ......                                   ...
;             ...   | ...                              ...
;          ...      |    ...                        ...
; .........---------+-------...------------------...---------
; |       |         |          ...            ...
; |       |         |             ...      ...
; |       |         |                ......
; |       |         |                  |
; |<Delay>|         | <-- x Steps  --> |
;
; 1 line =^= 1x Freq. Delta
; 1 column =^= 1 frame
; . - value of the current frequency


DoModulation:				; CODE XREF: ProcessTrack+1Dj
		ld	e, (ix+0Ah)	; load current Mod. Freq. into DE
		ld	d, (ix+0Bh)
		
		bit	4, (ix+18h)		; Note: This jump is not present in the original driver,
		jp	nz, KeepFrequency	;       but this fixes the Title Screen in FM mode.
		
		ld	a, (ix+19h)	; load Initial Modulation Delay
		and	a
		jr	z, loc_4424	; is already zero - process modulation
		dec	(ix+19h)	; else decrement
		jp	KeepFrequency
; ---------------------------------------------------------------------------

loc_4424:				; CODE XREF: ProcessTrack+3Ej
		dec	(ix+1Ah)	; decrement Modulation Tick Delay
		jp	nz, KeepFrequency	; and skip unless it reached zero
		
		ld	l, (ix+14h)	; load Modulation Pointer
		ld	h, (ix+15h)
		inc	hl		; HL = &ModData[01h] (formerly ix+15h)
		ld	a, (hl)
		ld	(ix+1Ah), a	; reload Mod. Tick Delay
		
		;ld	l, (ix+1Ch)	; load Frequency Delta
		;ld	h, (ix+1Dh)
		dec	(ix+1Bh)	; decrement Step Count
		jp	nz, loc_4452	; not yet zero - jump
		inc	hl		; HL = &ModData[02h] (formerly ix+16h)
		ld	a, (hl)
		ld	(ix+1Bh), a	; reset Step Count
		
		;ld	a, l		; then negate HL (2's complement)
		ld	a, (ix+1Ch)	; load Frequency Delta
		ld	h, (ix+1Dh)
		cpl
		ld	l, a
		ld	a, h
		cpl
		ld	h, a
		inc	hl
		ld	(ix+1Ch), l	; write negated Freq. Delta back
		ld	(ix+1Dh), h
		jp	KeepFrequency
; ---------------------------------------------------------------------------

loc_4452:				; CODE XREF: ProcessTrack+5Bj
		ld	l, (ix+1Ch)	; load Frequency Delta
		ld	h, (ix+1Dh)
		add	hl, de		; modify frequency HL by DE
		ld	(ix+0Ah), l	; and write back
		ld	(ix+0Bh), h
		ex	de, hl
		jp	SendFrequency

KeepFrequency:
		bit	5, (ix+18h)	; Do we need to send the frequency?
		;ret	z		; no - return
		jp	nz, SendFrequency
		
		bit	7, (ix+00h)
		ret	z		; If we're in FM mode, we can return instantly
		jp	SendVolume	; PSG mode - refresh volume
		
	;	bit	7, (ix+00h)
	;	ret	z		; If we're in FM mode, we can return instantly
	;	; If we're in PSG mode, we need to process everything, because
	;	; 1. the frequency is not written before and
	;	; 2. the volume needs to be sent, too.

SendFrequency:				; CODE XREF: ProcessTrack+43j
					; ProcessTrack+49j ...
		ld	l, (ix+06h)	; read raw Frequency into HL
		ld	h, (ix+07h)
		ld	c, (ix+08h)	; read Freq. Detune into BC
		ld	b, (ix+09h)
		
		add	hl, bc		; apply Freq. Detune
		add	hl, de		; apply Freq. Modulation
		res	5, (ix+18h)	; frequency sent once - mark as "refresh only when necessary"
		bit	7, (ix+00h)
		jp	z, SendFMFreq
		
		ld	a, (ix+1Fh)	; get Octave Shift
		and	a
		ld	b, a		; half HL Octave times
		ld	a, l
		jr	z, loc_4475	; Octave Shift == 0 -> skip

loc_446F:				; CODE XREF: ProcessTrack+95j
		srl	h
		;rr	l
		rra
		djnz	loc_446F
; PSG Frequencies have a range of 000..3FF
; Frequency 123 is written to the chip as x3 12
; (x is the Channel/Frequency Bits, 8/A/C/E)

loc_4475:				; CODE XREF: ProcessTrack+8Ej
		;ld	a, l
		ld	l, a
		and	0Fh		; mask high 4 bits out
		or	(ix+00h)	; add Channel Frequency Bits in
		out	(7Fh), a	; send Frequency LSB to chip
		ld	a, h		; get high frequency byte
		rlca			; extract lower nibble and shift <<4
		rlca
		rlca
		rlca
		and	0F0h
		ld	c, a		; save into C
		ld	a, l		; get low frequency byte
		rrca			; extract higher nibble and shift >>4
		rrca
		rrca
		rrca
		and	0Fh
		or	c
		out	(7Fh), a

SendVolume:				; CODE XREF: ProcessTrack+26j
					; ProcessTrack+31j
		ld	a, (ix+05h)	; load Fade Ticks MSB
		and	a
		jr	z, loc_44A7	; already 0 - skip
		ld	c, a
		ld	a, (ix+0Ch)	; load Envelope Level
		and	a
		jr	z, loc_44A7	; already 0 - skip
		ld	l, a
		ld	h, 0
		call	CalcTickTime	; HL = (HL * C)
		rl	l
		ld	a, 0
		adc	a, h

loc_44A7:				; CODE XREF: ProcessTrack+B5j
					; ProcessTrack+BCj
		and	(ix+1Eh)	; get effective Volume (00..0F)
	if PSG_VolReduce > 0
		;bit	7, (ix+TrackSize)	; check, if the Music Track uses FM
		;jr	nz, sendvol_nofm
		sub	a, PSG_VolReduce	; if so, make PSG quieter
		jr	nc, sendvol_nofm
		xor	a
sendvol_nofm:
	endif
		xor	0Fh		; make 0F..00 -> 00..0F
		or	(ix+01h)	; add Channel Volume Bits (90/B0/D0/F0)
		out	(7Fh), a	; send to PSG chip
		
;CalcFadeVol:
		ld	a, (PlaybackMode)
		and	8
		ret	z		; not fading - return
		bit	7, (ix+17h)	; is SFX track?
		ret	nz		; yes - return
CalcFadeVol:
		ld	l, (ix+04h)
		ld	h, (ix+05h)
		ld	bc, (FadeTickDec)
		sbc	hl, bc
		jr	nc, loc_44CE
		ld	hl, 0

loc_44CE:				; CODE XREF: ProcessTrack+EBj
		ld	(ix+04h), l
		ld	(ix+05h), h
		
		bit	7, (ix+00h)
		ret	nz		; PSG mode - we're finished
		ld	a, h
		jp	RefreshFMVol

SendFMFreq:
		ld	b, (ix+1Fh)	; get real Octave
		ld	a, h
		or	a
		;jp	m, sfmfrq_OctOK	; ignore negative frequencies
		ret	m		; don't send negative frequencies (they would require me to mask the KeyOn bit off)
		
		cp	02h		; FNum overflow? (>= 0200h)
		jr	c, sfmfrq_OctOK
sfmfrq_FNumLimit:
		rra			; yes - shift right and increase octave
		rr	l
		inc	b
		inc	b
		cp	02h		; and check again ...
		jr	nc, sfmfrq_FNumLimit
		ld	h, a
		
		; now verify that the Octave didn't overflow
		ld	a, b
		cp	08h<<1
		jr	c, sfmfrq_OctOK
		ld	b, 07h<<1
sfmfrq_OctOK:
		
		ld	c, 0F1h
		ld	a, (ix+00h)
		sub	a, 10h
		out	(0F0h), a	; Register 1x: Frequency LSB
		YMWait_Reg	19
		ld	a, (ix+06h)
		out	(c), l		; Data
		;YMWait_Data
		
		; We need to wait for the YM2413 anyway, so let's do some work here. (4+4+19+19 = 46 cycles)
		ld	a, h
		or	b		; add octave
		or	(ix+1Eh)
		ld	b, a
		
		ld	a, (ix+00h)
		out	(0F0h), a	; Register 2x: Frequency MSB / Key On/Off
		;YMWait_Reg	4+4+19
		YMWait_Reg
		out	(c), b		; Data: Frequency with Key On/Off
		ret

; ---------------------------------------------------------------------------
; 15 frequencies: C0..B0, A-1, A#-1, B-1
PSGFreqVals:	dw 356h, 326h, 2F9h, 2CEh, 2A5h, 280h, 25Ch, 23Ah
					; DATA XREF: UpdateTrack+59o
		dw 21Ah, 1FBh, 1DFh, 1C4h
LowPSGFreqVals:	dw 3F7h, 3BEh, 388h

;FMFreqVals:	dw 101h, 110h, 120h, 131h, 143h, 157h, 16Bh, 181h
;		dw 198h, 1B0h, 1CAh, 1E5h
FMFreqVals:	dw 0ADh, 0B7h, 0C2h, 0CEh, 0DAh, 0E7h, 0F4h, 103h
		dw 112h, 123h, 134h, 146h
; ---------------------------------------------------------------------------

DoCommand:				; CODE XREF: UpdateTrack+1Bj
		;cp	0FFh		; handle the special Track End commands
		;jp	z, cFF_StopMusTrk
		;cp	0FEh
		;jp	z, cFE_StopSFXTrk
		
		inc	de		; for all others, use the Command Pointer List
		ld	hl, CmdPtrList
		sub	0E0h		; E0..FF -> 00..1F
		add	a, a
		ld	c, a
		ld	b, 0
		add	hl, bc		; HL = &CmdPtrList[A]
		ld	a, (hl)		; read the address from there into HL
		inc	hl
		ld	h, (hl)
		ld	l, a
		jp	(hl)
; ---------------------------------------------------------------------------

cFF_StopTrack:
		bit	7, (ix+17h)	; is SFX track?
		jr	nz, cFE_StopSFXTrk	; yes - jump
		; fall through to StopMusTrk

cFF_StopMusTrk:				; CODE XREF: ProcessTrack+117j
		ld	l, (ix+27h)	; read Master Loop address
		ld	h, (ix+28h)
		ld	a, l
		or	h
		jr	z, StopTrack	; If it is 0, end the track normally.
		ex	de, hl		; else make it continue at the Master Loop address
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

cFE_StopSFXTrk:				; CODE XREF: ProcessTrack+11Cj
		xor	a
		ld	(CurSFXPrio), a	; reset current Sound Priority
		
		;set "require to send frequency" bit for all PSG tracks SFX can override
		ld	hl, MusTrk0+18h
		set	5, (hl)
		ld	hl, MusTrk1+18h
		set	5, (hl)
		ld	hl, MusTrk2+18h
		set	5, (hl)
		ld	hl, MusTrk3+18h
		set	5, (hl)

StopTrack:				; CODE XREF: ProcessTrack+135j
		;res	1, (ix+18h)	; mark track as 'not in use'
		ld	(ix+18h), a	; disable track
		ld	(ix+1Eh), a	; set Note Off
		
		bit	7, (ix+00)	; check FM mode
		jr	z, StopTrkFM
		
		ld	a, 0Fh		; Volume 0F = silence
		or	(ix+01h)	; add Channel and Volume Bits (90/B0/D0/F0)
		out	(7Fh), a	; send to PSG chip
		ret
StopTrkFM:
		; This sound horrible with fading tones.
		;ld	a, (ix+00h)
		;out	(0F0h), a	; Register: 2x (Key On/Off)
		;YMWait_Reg	4
		;xor	a
		;out	(0F1h), a	; Data 00 - Key Off
		
		bit	7, (ix+16h)
		jp	nz, UpdTrk_FMDrum
		
		; calculate carrry of Frequency LSB
		ld	a, (ix+06h)	; raw Frequency LSB
		add	a, (ix+08h)	; Frequency Detune LSB
		
		ld	a, (ix+00h)
		out	(0F0h), a	; Register 2x: Key On/Off
		YMWait_Reg	19+19+19
		ld	a, (ix+07h)	; raw Frequency MSB
		adc	a, (ix+09h)	; Frequency Detune MSB
		or	(ix+1Fh)
		out	(0F1h), a	; Data: Frequency with Key On/Off (depending on +1Eh)
		ret
; ---------------------------------------------------------------------------
CmdPtrList:				; DATA XREF: ProcessTrack+120o
		dw cE0_Tempo, cE1_SetVol, cE2_SetIns, cE3_Modulation	; E0..E3
		dw cE4_SetDetune, cE5_dummy, cE6_LoopStart, cE7_LoopEnd	; E4..E7
		dw cE8_LoopJump, cE9_NoiseMode, cEA_Hold, cEB_ChgVol	; E8..EB
		dw cEC_VolUp, cED_VolDown, cEE_SetTransp, cEF_ChgTransp	; EC..EF
		dw cF0_OctaveUp, cF1_OctaveDown, TrackReadLoop, TrackReadLoop	; F0..F3
		dw TrackReadLoop, TrackReadLoop, TrackReadLoop, TrackReadLoop	; F4..F7
		dw TrackReadLoop, TrackReadLoop, TrackReadLoop, cFB_GoTo	; F8..FB
		dw cFC_GoSub, cFD_Return, cFF_StopTrack, cFF_StopTrack	; FC..FF
	; E0 - Tempo
	; E1 - Set Volume
	; E2 - Set Instrument (ADSR/FM)
	; E3 - Modulation
	; E4 - Detune
	; E5 - dummy
	; E6 - Loop Start
	; E7 - Loop End
	; E8 - Loop Jump
	; E9 - Noise Mode
	; EA - Hold Note
	; EB - Change Volume
	; EC - Volume Up
	; ED - Volume Down
	; EE - Set Transpose
	; EF - Change Transpose
	; F0 - Octave Up
	; F1 - Octave Down
	; FC - GoSub
	; FD - Return
	; FE - SFX Track End
	; FF - Music Track End
; ---------------------------------------------------------------------------
; ADSR Envelope:
;
;          ....                                 - maximum level
;         .|   ...
;        . |      ...
;       .  |         ......                     - Decay 1 level
;      .   |         |     ......
;     .    |         |           ......
;    .     |         |                 ..       - Decay 2 level
;   .      |         |                 | ..
;  .       |         |                 |   ..
; ---------+---------+-----------------+------- - minimum level
; | Attack | Decay 1 |     Decay 2     |Sustain
;
; level - what volume level has to be reached to advance to the next phase
; rate  - speed of the phase
;
; A NoteOn event starts the ADSR envelope in the attack phase.
; A NoteOff event stops the envelope and silences the tone immediately.

ADSREnv_Atk:				; CODE XREF: ProcessTrack+9j
		ld	a, (ix+0Eh)
		add	a, (ix+0Ch)	; EnvLevel += AttackRate
		jp	nc, loc_4550
		ld	a, 0FFh		; high limit is FF

loc_4550:				; CODE XREF: ProcessTrack+16Dj
		ld	(ix+0Ch), a	; store back
		jp	nc, DoTrkSoundOut
		inc	(ix+0Dh)	; addition overflowed -> EnvState = 01 (Decay 1)
		jp	DoTrkSoundOut
; ---------------------------------------------------------------------------

ADSREnv_Dec1:				; CODE XREF: ProcessTrack+Dj
		ld	c, (ix+10h)	; get Decay 1 Level (D1L)
		ld	a, (ix+0Ch)	; get ADSR Envelope Level
		sub	(ix+0Fh)	; EnvLevel -= Decay1Rate
		jr	c, loc_456D	; underflow - skip and set to D1L
		cp	(ix+10h)	; EnvLevel < D1L
		jr	c, loc_456D
		ld	c, a		; EnvLevel >= D1L -> load into C

loc_456D:				; CODE XREF: ProcessTrack+187j
					; ProcessTrack+18Cj
		ld	(ix+0Ch), c	; store C back (either EnvLevel or Decay1Level)
		jp	nc, DoTrkSoundOut
		inc	(ix+0Dh)	; reached D1L -> EnvState = 02 (Decay 2)
		jp	DoTrkSoundOut
; ---------------------------------------------------------------------------

ADSREnv_Dec2:				; CODE XREF: ProcessTrack+11j
		ld	c, (ix+12h)	; get Decay 2 Level (D2L)
		ld	a, (ix+0Ch)	; get ADSR Envelope Level
		sub	(ix+11h)	; EnvLevel -= Decay2Rate
		jr	c, loc_458B	; etc ... see ADSREnv_Dec1
		cp	(ix+12h)
		jp	c, loc_458B
		ld	c, a

loc_458B:				; CODE XREF: ProcessTrack+1A4j
					; ProcessTrack+1A9j
		ld	(ix+0Ch), c
		jp	nc, DoTrkSoundOut
		inc	(ix+0Dh)	; reached D2L -> EnvState = 03 (Sustain)
		jp	DoTrkSoundOut
; ---------------------------------------------------------------------------

ADSREnv_Sus:				; CODE XREF: ProcessTrack+15j
		ld	a, (ix+0Ch)
		sub	(ix+13h)	; EnvLevel -= SustainRate
		jp	nc, loc_45A2
		ld	a, 0		; lower limit is 0

loc_45A2:				; CODE XREF: ProcessTrack+1BFj
		ld	(ix+0Ch), a	; store back
		jp	nc, DoTrkSoundOut
		inc	(ix+0Dh)	; subtraction underflowed -> EnvState = 04 (keep current level)
		jp	DoTrkSoundOut
; End of function ProcessTrack

; ---------------------------------------------------------------------------

cE0_Tempo:				; DATA XREF: ProcessTrack:CmdPtrListo
		ld	a, (de)		; copy Tempo Divider ...
		;ld	(ix+22h), a	; copy to Track's Tick Multiplier (not necessary - it's going to use the global one anyway)
		ld	(TickMult+00h), a
		inc	de
		ld	a, (de)
		;ld	(ix+23h), a
		ld	(TickMult+01h), a
		inc	de
		ld	a, (de)		; copy Tempo Multiplier
		ld	c, a
		ld	(TickDiv1+00h), a
		ld	(TickDiv2+00h), a
		inc	de
		ld	a, (de)
		ld	b, a
		ld	(TickDiv1+01h), a
		ld	(TickDiv2+01h), a
		inc	de
		
		; Additional fix not present in the orignal driver (fixes "off by one frame" error)
		; fixes Bonus Zone -> Invincibility timing issue
		; Note: in order to be 100% correct with mid-song tempo changes, I'd need to do:
		;	HL = TrackTick + OldTickDiv - NewTickDiv
		;	However, at the beginning of the song, (TrackTick + OldTickDiv) = 1
		ld	hl, 0001
		and	a	; clear carry
		sbc	hl, bc
		ld	(ix+02h), l
		ld	(ix+03h), h
		
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

cEB_ChgVol:
		ld	a, (de)		; read PSG volume
		inc	de
		ld	c, (ix+00)
		bit	7, c		; check FM mode
		jr	nz, cEB_chgvol_fin
		ld	a, (de)		; read FM volume
cEB_chgvol_fin:
		or	a
		jr	z, cEB_chgvol_chk
		add	a, (ix+24h)
		jp	RefreshVolume

cEB_chgvol_chk:
		bit	7, (ix+16h)
		jr	nz, cEB_ret	; volume +0 on drum track - return and save a LOT of cycles
		add	a, (ix+24h)
		jp	RefreshVolume
cEB_ret:
		inc	de
		jp	TrackReadLoop

cE1_SetVol:				; DATA XREF: ProcessTrack:CmdPtrListo
		ld	a, (de)		; read PSG volume
		inc	de
		ld	c, (ix+00)
		bit	7, c		; check FM mode
		jr	nz, RefreshVolume
		ld	a, (de)		; read FM volume
RefreshVolume:
		ld	(ix+24h), a	; set Track Volume to A
		inc	de
		
		bit	7, (ix+17h)	; is SFX track?
		jr	nz, loc_45E5	; yes - jump
		ld	a, (PlaybackMode)
		and	8
		jp	nz, TrackReadLoop	; fading - return

loc_45E5:				; CODE XREF: BANK1:45DBj
		ld	a, (ix+24h)
		ld	(ix+05h), a
		ld	(ix+04h), 0
		
		bit	7, c		; check FM mode
		call	z, RefreshFMVol
		jp	TrackReadLoop

RefreshFMVol:
		bit	7, (ix+16h)
		jr	nz, RefreshFMDrumVol
		
		cpl
		and	0Fh
		;xor	0Fh
		ld	c, a		; save Volume
		
		ld	a, (ix+01h)
		out	(0F0h), a	; write Register
		
		ld	a, (ix+25h)	; get Instrument
		;and	0F0h
		or	c
		out	(0F1h), a	; write Data
		
		ret

RefreshFMDrumVol:
		cpl
		and	0Fh
		;xor	0Fh
		push	de
		
		ld	l, a
		rlca
		rlca
		rlca
		rlca
		ld	h, a
		; H has V0, L has 0V
		
		ld	c, 0F0h
		ld	b, (ix+01h)
		out	(c), b		; write Register 36
		
		ld	a, (ix+07)	; get Bass Drum volume
		cpl			; 0..F -> F..0 (per nibble)
		and	0Fh
		add	a, l
		ClipToVol0F
		out	(0F1h), a
		inc	b
		
		ld	a, (ix+08)	; get Snare Drum/Hi-Hat volume
		cpl			; 0..F -> F..0 (per nibble)
		ld	d, a
		and	0Fh		; Snare Drum volume only
		add	a, l		; add Volume (0V)
		ClipToVol0F
		ld	e, a		; save SD Volume nibble
		
		ld	a, d
		and	0F0h		; Hi-Hat volume only
		out	(c), b		; write Register 37
		add	a, h		; add Volume (V0)
		ClipToVolF0
		or	e		; add HH and SD volume together
		out	(0F1h), a
		inc	b
		
		ld	a, (ix+09)	; get Tom Tom/Cymbal volume
		cpl			; 0..F -> F..0 (per nibble)
		ld	d, a
		and	0Fh		; Tom Tom volume only
		add	a, l		; add Volume (0V)
		ClipToVol0F
		ld	e, a		; save TOM Volume nibble
		
		ld	a, d
		and	0F0h		; Cymbal volume only
		out	(c), b		; write Register 38
		add	a, h		; add Volume (V0)
		ClipToVolF0
		or	e		; add TOM and CYM volume together
		out	(0F1h), a
		
		pop	de
		ret
; ---------------------------------------------------------------------------

;cE2_SetADSR:				; DATA XREF: ProcessTrack:CmdPtrListo
;		push	ix
;		pop	hl
;		ld	bc, 0Eh
;		add	hl, bc
;		ex	de, hl		; DE = &TrkRAM[0E]
;		ldi			; copy 6 bytes
;		ldi
;		ldi
;		ldi
;		ldi
;		ldi
;		ex	de, hl
;		jp	TrackReadLoop
cE2_SetIns:				; DATA XREF: ProcessTrack:CmdPtrListo
		;bit	7, (ix+00h)
		;jr	nz, cE2_psg_ins
		ld	a, (ix+00h)
		or	a
		jp	m, cE2_psg_ins
		
		cp	23h	; is lower (20..22) or upper (23..25) FM channels?
		
		inc	de
		ld	a, (de)		; get FM Instrument ID
		inc	de
		
		; lower FM part - use low nibble
		; higher FM part - use high nibble
		jr	nc, cE2_upperFM
		rlca			; 00..0F -> 00..F0
		rlca
		rlca
		rlca
cE2_upperFM:
		and	0F0h
	;	jr	z, $
;		jr	nz, +
;		add	a, 10h
;+
		ld	(ix+25h), a
		
		ld	c, a
		
		; do some small optimization here
		ld	a, (de)
		cp	0E1h	; next command is SetVolume? (quite common after Instrument Changes)
		jp	z, TrackReadLoop	; if so, save some cycles - it will refresh the instrument
		cp	0EBh	; next command is Change Volume?
		jp	z, TrackReadLoop
		
		ld	a, (ix+01h)
		out	(0F0h), a	; write Register
		ld	a, (ix+05h)	; get Volume
		cpl
		and	0Fh
		;xor	0Fh
		or	c
		out	(0F1h), a	; write Data
		
		jp	TrackReadLoop

cE2_psg_ins:
		ld	a, (de)		; get PSG Instrument ID
		inc	de
		inc	de
		push	de
		
		push	ix
		pop	hl
		ld	bc, 0Eh
		add	hl, bc
		ex	de, hl		; DE = &TrkRAM[0E]
		
		ld	bc, InsLib_Music
		bit	7, (ix+17h)
		jr	z, cE2_ins_mus
		ld	bc, InsLib_SFX
cE2_ins_mus:
		ld	h, 00h
		ld	l, a
		add	hl, hl	; * 2
		add	hl, hl	; * 4
		add	hl, hl	; * 8
		add	hl, bc
		
		ldi			; copy 6 bytes
		ldi
		ldi
		ldi
		ldi
		ldi
		
		pop	de
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

cE3_Modulation:				; DATA XREF: ProcessTrack:CmdPtrListo
		set	4, (ix+18h)
		ld	(ix+14h), e
		ld	(ix+15h), d
		ld	hl, 0007h
		add	hl, de
		ex	de, hl
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

; PSG Mode:
;	E4 aabb xxxx - copies aa -> +08h, bb -> 09h
; FM Melody Mode:
;	E4 xxxx aabb - copies aa -> +08h, bb -> 09h
; FM Drum Mode:
;	E4 xxcc aabb - copies cc -> +07h, aa -> +08h, bb -> 09h
cE4_SetDetune:				; DATA XREF: ProcessTrack:CmdPtrListo
		bit	7, (ix+00h)
		jr	nz, cE4_copy_vals
		
		inc	de	; FM mode - skip the first word
		bit	7, (ix+16h)	; check FM Drum mode
		jr	z, cE4_normal_fm
		ld	a, (de)		; FM Drum: copy Bass Drum volume
		ld	(ix+07h), a
cE4_normal_fm:
		inc	de
		
cE4_copy_vals:
		; PSG/FM Melody: copy detune word
		ld	a, (de)		; FM Drum: copy SD/HH volume
		ld	(ix+08h), a
		inc	de
		ld	a, (de)		; FM Drum: copy Tom/Cym volume
		ld	(ix+09h), a
		inc	de
		
		bit	7, (ix+00h)
		jp	z, TrackReadLoop
		inc	de	; PSG mode - skip the last word
		inc	de
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

cE5_dummy:				; DATA XREF: ProcessTrack:CmdPtrListo
		ld	a, (de)		; This command reads 1 byte and does nothing with it.
		inc	de
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

cE6_LoopStart:				; DATA XREF: ProcessTrack:CmdPtrListo
		ld	a, (de)
		inc	de
		
		or	a		; Loop Count == 0 -> Master Loop
		jr	z, cE6_MasterLoop
		
		push	ix
		pop	hl
		dec	(ix+26h)	; decrement Stack Offset
		ld	b, 00h
		ld	c, (ix+26h)	; get Loop Stack Offset
		add	hl, bc
		ld	(hl), a		; initialize Loop Counter
		jp	TrackReadLoop

cE6_MasterLoop:				; DATA XREF: ProcessTrack:CmdPtrListo
		ld	(ix+27h), e	; write Master Loop address to TrkRAM+22/23
		ld	(ix+28h), d
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

cE7_LoopEnd:				; DATA XREF: ProcessTrack:CmdPtrListo
		push	ix
		pop	hl
		ld	b, 00h
		ld	c, (ix+26h)	; get Loop Stack Offset
		add	hl, bc
		
		dec	(hl)		; decrement Loop Counter
		jr	z, loc_4671	; reaching 0 -> end of the loop

Loop_JumpBack:				; CODE XREF: BANK1:465Aj
		ex	de, hl		; loop back
		;inc	hl
		ld	c, (hl)		; get relative address
		inc	hl
		ld	b, (hl)
		dec	hl
		add	hl, bc		; HL = new Data Offset
		ex	de, hl		; make it continue reading with that
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

loc_4671:				; CODE XREF: BANK1:4657j BANK1:465Ej
		inc	(ix+26h)	; increment Stack Offset (pop one loop)
		inc	de		; skip pointer
		inc	de
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

cE8_LoopJump:
		ld	a, (de)		; get Loop Jump Index
		inc	de
		
		push	ix
		pop	hl
		ld	b, 00h
		ld	c, (ix+26h)	; get Loop Stack Offset
		add	hl, bc
		
		cp	a, (hl)
		jr	z, cE8_take_jump
		
		inc	de		; skip pointer
		inc	de
		jp	TrackReadLoop

cE8_take_jump:
		ex	de, hl
		ld	c, (hl)		; get relative address
		inc	hl
		ld	b, (hl)
		dec	hl
		add	hl, bc		; HL = new Data Offset
		ex	de, hl		; make it continue reading with that
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

cE9_NoiseMode:				; DATA XREF: ProcessTrack:CmdPtrListo
		ld	a, (de)
		ld	(ix+25h), a	; The Noise Mode is refreshed when a note is played.
		inc	de
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

;cEA_DefaultLen:				; DATA XREF: ProcessTrack:CmdPtrListo
;		;ld	a, (de)
;		;ld	(ix+44h), a
;		inc	de
;		jp	TrackReadLoop
; ---------------------------------------------------------------------------

cEC_VolUp:				; DATA XREF: ProcessTrack:CmdPtrListo
		ld	a, (ix+24h)
		inc	a		; increase volume
		cp	10h
		jr	c, loc_46A0
		ld	a, 0Fh		; and limit to 0F

loc_46A0:				; CODE XREF: BANK1:469Cj
		ld	(ix+24h), a
		ld	a, (PlaybackMode)
		and	8
		jp	nz, TrackReadLoop
		ld	a, (ix+24h)
		ld	(ix+05h), a	; If fading enabled, then refresh TrkRAM+05
		
		bit	7, (ix+00)	; check FM mode
		call	z, RefreshFMVol
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

cED_VolDown:				; DATA XREF: ProcessTrack:CmdPtrListo
		ld	a, (ix+24h)
		dec	a		; decrease volume
		cp	10h
		jr	c, loc_46BD
		xor	a		; if overflowed to FF, limit to 00

loc_46BD:				; CODE XREF: BANK1:46BAj
		ld	(ix+24h), a
		ld	a, (PlaybackMode)
		and	8
		jp	nz, TrackReadLoop
		ld	a, (ix+24h)
		ld	(ix+05h), a	; If fading enabled, then refresh TrkRAM+05
		
		bit	7, (ix+00)	; check FM mode
		call	z, RefreshFMVol
		jp	TrackReadLoop
; ---------------------------------------------------------------------------

cEA_Hold:				; DATA XREF: ProcessTrack:CmdPtrListo
		set	0, (ix+18h)	; prevent it from retriggering the note the next time
		jp	TrackReadLoop

cEE_SetTransp:
		ld	a, (de)
		ld	(ix+16h), a
		inc	de
		jp	TrackReadLoop

cEF_ChgTransp:
		ld	a, (de)
		add	a, (ix+16h)
		ld	(ix+16h), a
		inc	de
		jp	TrackReadLoop

cF0_OctaveUp:
		ld	a, (ix+16h)
		add	a, 12
		ld	(ix+16h), a
		jp	TrackReadLoop

cF1_OctaveDown:
		ld	a, (ix+16h)
		sub	a, 12
		ld	(ix+16h), a
		jp	TrackReadLoop

cFB_GoTo:
		ex	de, hl
		ld	c, (hl)		; get relative address
		inc	hl
		ld	b, (hl)
		dec	hl
		add	hl, bc		; HL = new Data Offset
		ex	de, hl
		jp	TrackReadLoop

cFC_GoSub:
		inc	de
		inc	de
		
		push	ix
		pop	hl
		ld	b, 00h
		ld	c, (ix+26h)	; get Loop Stack Offset
		dec	c
		add	hl, bc
		
		ld	(hl), d		; save Offset MSB
		dec	c
		dec	hl
		ld	(hl), e		; save Offset LSB
		ld	(ix+26h), c
		
		ex	de, hl
		dec	hl
		ld	b, (hl)		; get relative address
		dec	hl
		ld	c, (hl)
		add	hl, bc		; HL = new Data Offset
		ex	de, hl
		jp	TrackReadLoop

cFD_Return:
		push	ix
		pop	hl
		ld	b, 00h
		ld	c, (ix+26h)	; get Loop Stack Offset
		add	hl, bc
		
		inc	c
		inc	c
		ld	(ix+26h), c
		
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		
		jp	TrackReadLoop
; =============== S U B	R O U T	I N E =======================================

; HL = (HL * C)

CalcTickTime:				; CODE XREF: UpdateTrack:loc_43B7p
					; ProcessTrack+C1p
		xor	a
		ld	b, 7
		ex	de, hl
		ld	l, a
		ld	h, a

loc_46DE:				; CODE XREF: CalcTickTime+Dj
		rl	c
		jp	nc, loc_46E4
		add	hl, de

loc_46E4:				; CODE XREF: CalcTickTime+8j
		add	hl, hl
		djnz	loc_46DE
		or	c
		ret	z
		add	hl, de
		ret
; End of function CalcTickTime


CalcTickTime_Opt:
		;xor	a
		ex	de, hl
		;ld	l, a
		;ld	h, a
		;add	b
		;ret	z
		ld	hl, 0000h
cttopt_loop:
		add	hl, de
		djnz	cttopt_loop
		ret


; =============== S U B	R O U T	I N E =======================================


PlayMusic:				; CODE XREF: j_PlayMusicj
		push	hl
		push	bc
		
		add	a, a
		ld	b, 00h
		ld	c, a
		
		ld	a, (0DC00h)
		rra			; check FM mode (Bit 0 -> Carry)
		ld	hl, MusPtrList_PSG
		jr	nc, pm_loadlist
		ld	hl, MusPtrList_FM
pm_loadlist:
		add	hl, bc		; HL = &MusPtrList[A]
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a		; HL = Pointer to Music Data
		call	LoadMusic
		
		pop	bc
		pop	hl
		ret
; End of function PlayMusic


; =============== S U B	R O U T	I N E =======================================


PlaySFX:				; CODE XREF: j_PlaySFXj
		push	hl
		push	de
		ld	hl, SFXPtrList
		add	a, a
		add	a, a
		ld	e, a
		ld	d, 0
		add	hl, de
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ld	a, (hl)
		ex	de, hl
		call	LoadSFX
		pop	de
		pop	hl
		ret
; End of function PlaySFX

; ---------------------------------------------------------------------------
MusPtrList_FM:	dw Music00_F, Music01_F, Music02_F, Music03_F, Music04_F, Music05_F
		dw Music06_F, Music07_F, Music08_F, Music09_F, Music0A_F, Music0B_F
		dw Music0B_F, Music0D_F, Music0E_F, Music0x_F, Music10_F, Music11_F
		dw Music00_F, Music13_F, Music14_F, Music15_F, Music16_F, Music17_F
MusPtrList_PSG:	dw Music00_P, Music01_P, Music02_P, Music03_P, Music04_P, Music05_P
					; DATA XREF: PlayMusic+1o
		dw Music06_P, Music07_P, Music08_P, Music09_P, Music0A_P, Music0B_P
		dw Music0B_P, Music0D_P, Music0E_P, Music0x_P, Music10_P, Music11_P
		dw Music00_P, Music13_P, Music14_P, Music15_P, Music16_P, Music17_P
SFXPtrList:	SFXListData	byte_7B27, 2	; DATA XREF: PlaySFX+2o
		SFXListData	byte_7B43, 2
		SFXListData	byte_7B74, 2
		SFXListData	byte_7B98, 2
		SFXListData	byte_7BBF, 2
		SFXListData	byte_7BE6, 2
		SFXListData	byte_7C18, 2
		SFXListData	byte_7C42, 2
		SFXListData	byte_7C5E, 1
		SFXListData	byte_7C8E, 1
		SFXListData	byte_7CB7, 2
		SFXListData	byte_7CD8, 1
		SFXListData	byte_7CFD, 1
		SFXListData	byte_7D24, 1
		SFXListData	byte_7D62, 2
		SFXListData	byte_7D62, 1
		SFXListData	byte_7D62, 2
		SFXListData	byte_7D62, 2
		SFXListData	byte_7D88, 2
		SFXListData	byte_7DB1, 1
		SFXListData	byte_7DB1, 2
		SFXListData	byte_7DB1, 2
		SFXListData	byte_7DB1, 2
		SFXListData	byte_7DE6, 1
		SFXListData	byte_7E0C, 1
		SFXListData	byte_7E2F, 2
		SFXListData	byte_7E48, 1
		SFXListData	byte_7E5C, 1
		SFXListData	byte_7E74, 1
		SFXListData	byte_7EA4, 1
		SFXListData	byte_7ECC, 2
		SFXListData	byte_7ECC, 2
		SFXListData	byte_7EE8, 2
		SFXListData	byte_7F08, 1
		SFXListData	byte_7F4E, 1
		SFXListData	byte_7F83, 2

InsLib_Music:
	binclude "Mus_InsLib.bin"
InsLib_SFX:
	binclude "SFX_InsLib.bin"

	include "MusSFXData.asm"

		db	0A2h
		db	"SONIC THE HEDGEHOG"
		db	0A3h, "Master System & Game Gear Version.  "
		db	"'1991 (C)Ancient. "
		db	"(BANK0-4)"
; end of 'BANK1'

; RAM contents:
;RAM:DC00                 db    0
;RAM:DC01                 db    0
;RAM:DC02                 db    0
;RAM:DC03                 db    0
;RAM:DC04 PlaybackMode:   db 0                    ; DATA XREF: BANK1:TrkInitVals2o
PlaybackMode	= 0DC04h
;RAM:DC04                                         ; StopAllSound+38r ...
;RAM:DC05 OverriddenTrk:  db 0                    ; DATA XREF: LoadSFX+1Cw
OverriddenTrk	= 0DC05h
;RAM:DC05                                         ; UpdateSound+78r
;RAM:DC06 CurSFXPrio:     db 0                    ; DATA XREF: BANK1:TrkInitVals2o
CurSFXPrio	= 0DC06h
;RAM:DC06                                         ; StopAllSound+2Cw ...
;RAM:DC07 CurNoiseMode:   db 5                    ; DATA XREF: ProcessTrack+22r
CurNoiseMode	= 0DC07h
;RAM:DC07                                         ; ProcessTrack+2Aw
;RAM:DC08 TickMult:       dw 1                    ; DATA XREF: UpdateTrack+C0r
TickMult	= 0DC08h
;RAM:DC08                                         ; BANK1:45B2w ...
;RAM:DC0A TickDiv1:       dw 1                    ; DATA XREF: BANK1:TrkInitVals1o
TickDiv1	= 0DC0Ah
;RAM:DC0A                                         ; UpdateSound+8r ...
;RAM:DC0C TickDiv2:       dw 1                    ; DATA XREF: BANK1:45C2w
TickDiv2	= 0DC0Ch
;RAM:DC0C                                         ; BANK1:45CAw
;RAM:DC0E TickDivSFX:     dw 0                    ; DATA XREF: LoadSFX+2Cw
TickDivSFX	= 0DC0Eh
;RAM:DC0E                                         ; UpdateSound+64r
;RAM:DC10 FadeTicks:      dw 0                    ; DATA XREF: FadeOut+10w
FadeTicks	= 0DC10h
;RAM:DC10                                         ; UpdateSound+A7r ...
;RAM:DC12 FadeTickDec:    dw 0                    ; DATA XREF: FadeOut+2w
FadeTickDec	= 0DC12h
;RAM:DC12                                         ; UpdateSound+AAr ...
;RAM:DC14 Chn0TrkPtr:     dw MusTrk0              ; DATA XREF: UpdateSound+Fw
Chn0TrkPtr	= 0DC14h
;RAM:DC14                                         ; UpdateSound+75o ...
;RAM:DC16 Chn1TrkPtr:     dw MusTrk1              ; DATA XREF: UpdateSound+26w
Chn1TrkPtr	= 0DC16h
;RAM:DC16                                         ; UpdateSound+8Cr
;RAM:DC18 Chn2TrkPtr:     dw MusTrk2              ; DATA XREF: UpdateSound+3Dw
Chn2TrkPtr	= 0DC18h
;RAM:DC18                                         ; UpdateSound+93r
;RAM:DC1A Chn3TrkPtr:     dw MusTrk3              ; DATA XREF: UpdateSound+54w
Chn3TrkPtr	= 0DC1Ah
;RAM:DC1A                                         ; UpdateSound+9Ar
;RAM:DC1C Trk0DataPtr:    dw 4852h                ; DATA XREF: LoadMusic+8o
Trk0DataPtr	= 0DC1Ch
;RAM:DC1C                                         ; UpdateSound+4r ...
;RAM:DC1E Trk1DataPtr:    dw 4989h                ; DATA XREF: UpdateSound+1Br
Trk1DataPtr	= 0DC1Eh
;RAM:DC1E                                         ; UpdateSound+2Aw
;RAM:DC20 Trk2DataPtr:    dw 4AFBh                ; DATA XREF: UpdateSound+32r
Trk2DataPtr	= 0DC20h
;RAM:DC20                                         ; UpdateSound+41w
;RAM:DC22 Trk3DataPtr:    dw 4CF6h                ; DATA XREF: UpdateSound+49r
Trk3DataPtr	= 0DC22h
;RAM:DC22                                         ; UpdateSound+58w
;RAM:DC24 SFXTrkDataPtr:  dw 47D0h                ; DATA XREF: LoadSFX+31w
SFXTrkDataPtr	= 0DC2Eh
;RAM:DC24                                         ; UpdateSound+60r ...
;RAM:DC26 MusTrk0:        db 80h, 90h, 12h, 0, 0, 0Ch, 56h, 3, 0, 0, 0, 0, 0AFh
;SFXTrk		= 0DC26h
SFXTrk		= 0DC30h
MusTrk0		= SFXTrk  + TrackSize
MusTrk1		= MusTrk0 + TrackSize
MusTrk2		= MusTrk1 + TrackSize
MusTrk3		= MusTrk2 + TrackSize
MusTrk_End	= MusTrk0 + 7 * TrackSize
;RAM:DC26                                         ; DATA XREF: BANK1:TrkInitVals2o
;RAM:DC26                                         ; UpdateSoundo ...
;RAM:DC26                 db 1, 0FFh, 14h, 96h, 0, 32h, 0Ah, 0Ch, 1, 4, 5, 0, 6
;RAM:DC26                 db 1, 2, 5, 0, 0Fh, 2, 7, 0DDh, 0, 0, 0Ch, 0, 1, 0, 2
;RAM:DC26                 db 0D0h, 47h, 0, 0Ch
;RAM:DC53 MusTrk1:        db 0A0h, 0B0h, 6, 0, 0, 9, 56h, 3, 0, 0, 0, 0, 0, 0, 0FFh
;RAM:DC53                                         ; DATA XREF: BANK1:TrkInitVals2o
;RAM:DC53                                         ; UpdateSound+17o ...
;RAM:DC53                 db 1Eh, 96h, 0, 32h, 0Ah, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
;RAM:DC53                 db 0Fh, 0, 0Dh, 0DDh, 0, 0, 0Ch, 0, 0, 0, 2, 0D0h, 47h
;RAM:DC53                 db 1, 9
;RAM:DC80 MusTrk2:        db 0C0h, 0D0h, 1, 0, 0, 9, 0FBh, 1, 0, 0, 0, 0, 87h, 1
;RAM:DC80                                         ; DATA XREF: BANK1:TrkInitVals2o
;RAM:DC80                                         ; UpdateSound+2Eo ...
;RAM:DC80                 db 0FFh, 1Eh, 82h, 0, 32h, 0Ah, 0, 0, 4, 0, 0, 0, 0FAh
;RAM:DC80                 db 2, 0, 0, 0Fh, 2, 0Eh, 0DDh, 0, 0, 6, 0, 0, 0, 2, 0D0h
;RAM:DC80                 db 47h, 2, 9
;RAM:DCAD MusTrk3:        db 0E0h, 0F0h, 7, 0, 0, 0Ch, 0, 0, 0, 0, 0, 0, 6Fh, 1
;RAM:DCAD                                         ; DATA XREF: BANK1:TrkInitVals2o
;RAM:DCAD                                         ; UpdateSound+45o ...
;RAM:DCAD                 db 0E6h, 24h, 5Ah, 14h, 28h, 8, 0, 0, 0, 0, 0, 0, 0, 0
;RAM:DCAD                 db 0, 0, 0Fh, 0, 0Fh, 0DDh, 0EBh, 4Ch, 0Ch, 5, 0, 0, 2
;RAM:DCAD                 db 0D0h, 47h, 3, 0Ch
;RAM:DCDA SFXTrk:         db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
;RAM:DCDA                                         ; DATA XREF: LoadSFX+3Dw
;RAM:DCDA                                         ; UpdateSound+5Co ...
;RAM:DCDA                 db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
;RAM:DCDA                 db 0, 0, 0, 0, 0, 0, 0, 0, 0
;RAM:DD07 TrkLoopStack:   db 0, 10h, 5, 4, 0      ; DATA XREF: LoadSFX+5Do
;TrkLoopStack	= 0DD07h
; TrkLoopStack has a variable size, depending on the maximum layer of nested loops.
